function [edge2nodes,element2edges,varargout] = provideEdgeData(elements,varargin)

nE = size(elements,1);
nB = nargin-1;

%*** Node vectors of all edges (interior edges appear twice) 
I = elements(:);
J = reshape(elements(:,[2,3,1]),3*nE,1);

%*** Symmetrize I and J (so far boundary edges appear only once)
pointer = [1,3*nE,zeros(1,nB)];
for j = 1:nB
    boundary = varargin{j};
    if ~isempty(boundary)
        I = [I;boundary(:,2)];
        J = [J;boundary(:,1)];
    end
    pointer(j+2) = pointer(j+1) + size(varargin{j},1);
end

%*** Create numbering of edges
idxIJ = find(I < J);
idxJI = find(I > J);
[tmp1,tmp2,v1] = find( sparse(I(idxIJ),J(idxIJ),1:length(idxIJ)) );
[tmp1,tmp2,v2] = find( sparse(J(idxJI),I(idxJI),idxJI) );
edges = zeros(length(I),1);
edges(idxIJ) = 1:length(idxIJ);
edges(v2) = v1;

%*** Provide element2edges and edge2nodes
element2edges = reshape(edges(1:3*nE),nE,3);
edge2nodes = [I(idxIJ),J(idxIJ)];

%*** Provide boundary2edges
for j = 1:nB
    varargout{j} = edges(pointer(j+1)+1:pointer(j+2));
end
